# this is the file for estimation the precision matrix for miRNA and mRNA using lasoo graphical model.
# My algorithm is miRLasso, use joint penalty for maximum likelihod to estimate the matrix
#miRLasso function
#
#
import math
import numpy
import os
import pandas
import multiprocessing
from sklearn.preprocessing import Imputer


#def miRLasso():
    
def loadData(): #FileDir):
    """Read in data from a given directory"""
    #with open (FileDir, 'rb') as csvfile:
	#d = numpy.genfromtxt(csvfile, dtype=None)
    #return numpy.array(pandas.read_csv(FileDir))
    inFile = open('C:\___DATA\___________________PAPER 1________\Coding\Dataset\data-test.txt','r')
    dataMatrix = numpy.genfromtxt(inFile, delimiter='\t', skip_header=1)#, dtype=float, delimiter=',', names=True)
   # imp = Imputer(missing_values='NaN', strategy='mean', axis=0)
    #dataMatrix = pandas.read_csv(inFile, header=1, keep_default_na=True, na_values=[""])
    
    
    #print(dataMatrix)
    #dataMatrix.fillna(value=1)
    return dataMatrix

def covEstS(data, assume_centered=False):
    """Computes the covariance
    Parameters
    ----------
    X : 2D ndarray, shape (n_samples, n_features)
        Data from which to compute the covariance estimate

    assume_centered : Boolean
        If True, data are not centered before computation.
        Useful when working with data whose mean is almost, but not exactly
        zero.
        If False, data are centered before computation.

    Returns
    -------
    covariance : 2D ndarray, shape (n_features, n_features), Empirical covariance.

    """
    X = numpy.asarray(data)
    if X.ndim == 1:
        X = numpy.reshape(X, (1, -1))
        #warnings.warn("Only one sample available. "
                      #"You may want to reshape your data array")

    if assume_centered:
        covariance = numpy.dot(X.T, X) / X.shape[0]
    else:
        covariance = numpy.cov(X.T, bias=1)

    return covariance
    

def estimateTheta(St, initTheta, l1, l2, rho=1., max_iter=5, tol=.00001):
    """
    Function to estimate \Theta 
    
    INPUT:
	  - St: estimate of covariance
	  - oldTheta: estimate of \Theta . Will enforce sparse differences in order to encourage temporal homogeneity
	  - l1, l2: sparity and temporal homogeneity parameters
	  - rho: stepsize parameter, can be set to 1 (usually!)
	  - max_iter: maximum number of ADMM iterations
	  - tol: convergence criterion
    
    """

    iter_ = 0 
    convergence = False
    
    # initialise theta, Z and U:
    #theta = numpy.identity(oldTheta.shape[0])
    #Z = numpy.zeros((St.shape[0], St.shape[0]))
    theta = numpy.array(initTheta, copy=True)
    Z = numpy.array(initTheta, copy=True)
    Zold = numpy.array(Z, copy=True)
    U = numpy.array(Z, copy=True)
    
    # ADMM iters:
    while ((convergence==False) & (iter_ < max_iter)):
	# theta step:
	theta = minimize_theta(S_ = St - rho*Z + rho * U)
	# Z step with new theta:
	Z = minimize_Z(A = theta + U, oldTheta=theta, l1=l1, l2=l2)
	# U step:
	U += (theta - Z)
	
	# check convergence:
	convergence = check_conv1D(theta=theta, Z=Z, Zold=Zold, tol=tol)
	iter_ += 1
	Zold = numpy.array(Z, copy=True)
    #print iter_
    return theta, convergence, iter_


def minimize_theta(S_, rho=1, obs=1):
    """1st step: Minimize theta step of the ADMM algorithm
    input:
	- S_ = S_i - rho/obs * Z_i + rho/obs * U_i where S_i is ith entry of S (covariance estimates)
    output:
	- new update of theta_i"""
    D, V = numpy.linalg.eig(S_)
    
    D_ = numpy.identity(len(D)) * [obs/(2. * rho) * (-x + math.sqrt(x*x + 4.*rho/obs)) for x in D]

    return numpy.dot(numpy.dot(V, D_), V.T)


def minimize_Z(A, oldTheta, l1, l2, rho=1.):
    """2nd step: Minimize Z step of the ADMM algorithm for solving 
    input:
	- A is a numpr array such that A = theta + U. This is essentially my y is in my fused lasso-ish problem
	- oldTheta: estimate of \Theta_{t-1}, new estimate will be constrained by this
    outout:
	- new update of Z (numpy array)"""
    
    sudoZ = numpy.array(A, copy=True)
    
    # go through upper triangular part of the matrix:
    for i in range(A.shape[0]):
	for j in range(i, A.shape[0]):
	    y = A[i,j]
	    alpha = oldTheta[i,j] # value which will constain new estimate \Theta_t
	    
	    searchRange = numpy.linspace( min(0, y, alpha), max(0, y, alpha), num=100)
	    scoreEval = 0.5*(y - searchRange)*(y-searchRange) + l1*abs(searchRange) + l2*abs(searchRange - alpha)
	    
	    newB = searchRange[numpy.argmin(scoreEval)] # new entry in \Theta_t[i,j]
	    sudoZ[i,j] = newB
	    sudoZ[j,i] = newB
	    
    return sudoZ	

def choosel1Val(self, newX):
	"""
	Choose regularisation penalty (l1) based on look-ahead likelihood. 
	Since this observation is unseen we don't need to penalise (i.e., do AIC/BIC type penalties)
	
	Given new observation newX, we choose from a grid search on l1 value. We search: l1-epsilon,l1, l1+epsilon
	
	"""
	
	centeredX = newX -  self.mu[ self.mu.shape[0]-1, : ]
	
	LL = numpy.array([0.]*3) # store loglikelihood (LL) for each of the 3 potential models
	
	# lower penalisation:
	LL[0] = 0.5*numpy.log( numpy.linalg.det(self.Zlower) ) - 0.5*numpy.dot( centeredX.transpose(), numpy.dot(self.Zlower, centeredX ))
	
	# current penalisation:
	LL[1] = 0.5*numpy.log( numpy.linalg.det(self.Z[-1]) ) - 0.5*numpy.dot( centeredX.transpose(), numpy.dot(self.Z[-1], centeredX ))

	# higher penalisation:
	LL[2] = 0.5*numpy.log( numpy.linalg.det(self.Zupper) ) - 0.5*numpy.dot( centeredX.transpose(), numpy.dot(self.Zupper, centeredX ))
	
	#print LL
	
	if len(numpy.unique(LL))<3:
	    ii = 1 # there is a draw, stay on same penalisation value
	else:
	    ii = LL.argmax()
	
	return ii
    
def check_conv1D(theta, Z, Zold, tol):
    """Check convergence of the ADMM algorithm"""
    cond1 = True
    cond2 = True
    if ( ((abs(theta-Z))**2).sum() >= tol):
	cond1 = False
    if ( ((abs(Z - Zold))**2).sum() >= tol):
	cond2 = False
    return cond1 & cond2

"""
implementation of the miRLasso algorithm.
"""    
data =loadData()
covariance = covEstS(data, False)
#print covariance
initTheta = numpy.zeros((covariance.shape[0], covariance.shape[0]))
l1=1 # later update to estimation from data
#l1 = choosel1Val(data)
l2=.5
#get estimate of precision:
estTheta, conv, iter_ = estimateTheta(covariance, initTheta, l1, l2)
print estTheta
print conv
print iter_
#return estTheta
    
# estimate the precision matrix
#theta = miRLasso()   
# store the result matrix#############
numpy.savetxt('C:\___DATA\___________________PAPER 1________\Coding\Dataset\est-precision.txt', estTheta, fmt='%.4f', delimiter='\t', newline='\n', header='')#header)

## small sim
#from pylab import *
#plot(estTheta)

#show()


